(function($) {
	//全局配置(通常所有页面引用该配置，特殊页面使用mui.init({})来覆盖全局配置)
	$.initGlobal({
		gestureConfig: {
			tap: true, //默认为true
			doubletap: true, //默认为false
			longtap: true, //默认为false
			swipe: true, //默认为true
			drag: true, //默认为true
			hold: false, //默认为false，不监听
			release: false //默认为false，不监听
		},
		swipeBack: false //是否启动右滑返回
	});
	var back = $.back;
	$.back = function() {

		var current = plus.webview.currentWebview();
		if(current.mType === 'main') { //模板主页面
			//关闭搜索
			current.evalJS('hideSearch()');
			current.hide('auto');
			setTimeout(function() {
				document.getElementById("title").className = 'mui-fadeout';
				current.children()[0].hide("none");
				//关闭批量操作 HY
				current.children()[0].evalJS("if(typeof wSelect !='undefined')wSelect.disableChecked()");

			}, 200);
		} else if(current.mType === 'sub') {
			//关闭批量操作 HY
			if(typeof wSelect != 'undefined')
				wSelect.disableChecked();
			if($.targets._popover) {
				$($.targets._popover).popover('hide');
			} else {
				current.parent().evalJS('mui&&mui.back();');
			}
		} else {
			back();
		}
	}
})(mui);

/**
 * toggle
 */
window.addEventListener('toggle', function(event) {
	if(event.target.id === 'M_Toggle') {
		var isActive = event.detail.isActive;
		var table = document.querySelector('.mui-table-view');
		var card = document.querySelector('.mui-card');
		if(isActive) {
			card.appendChild(table);
			card.style.display = '';
		} else {
			var content = document.querySelector('.mui-content');
			content.insertBefore(table, card);
			card.style.display = 'none';
		}
	}
});

var templates = {};

var getTemplate = function(name, header, content, loading) {
	var template = templates[name];
	if(!template) {
		//预加载共用父模板；
		var headerWebview = mui.preload({
			url: header,
			id: name + "-template",
			styles: {
				popGesture: "hide"
			},
			extras: {
				mType: name
			}
		});
		//预加载共用子webview
		var subWebview = mui.preload({
			url: !content ? "" : content,
			id: name + "-sub",
			styles: {
				top: '60px',
				bottom: '0px'
			},
			extras: {
				mType: 'sub'
			}
		});
		subWebview.addEventListener('loaded', function() {
			setTimeout(function() {
				subWebview.show();
			}, 50);
		});
		subWebview.hide();
		headerWebview.append(subWebview);
		//iOS平台支持侧滑关闭，父窗体侧滑隐藏后，同时需要隐藏子窗体；
		if(mui.os.ios) { //5+父窗体隐藏，子窗体还可以看到？不符合逻辑吧？
			headerWebview.addEventListener('hide', function() {
				subWebview.hide("none");
			});
		}
		templates[name] = template = {
			name: name,
			header: headerWebview,
			content: subWebview,
			loaded: loading
		};
	}
	return template;
};　　
String.prototype.trim = function() {　　
	return this.replace(/(^\s*)|(\s*$)/g, "");　　
}　　
String.prototype.ltrim = function() {　　
	return this.replace(/(^\s*)/g, "");　　
}　　
String.prototype.rtrim = function() {　　
		return this.replace(/(\s*$)/g, "");　　
	}
	//主列表点击事件
function setNavHref(a) {
	var id = a.getAttribute('href');
	var type = a.getAttribute("open-type");
	var btn = a.getAttribute("header-button");
	if(btn == null) {
		btn = 'add';
	}
	if(type == "common") {
		if(~id.indexOf('offcanvas-')) {
			var pop = ~id.indexOf('offcanvas-with-right') ? "close" : "none";
			mui.openWindow({
				id: id,
				url: a.href,
				styles: {
					zindex: 9998,
					popGesture: pop
				},
				show: {
					autoShow: true,
					aniShow: animation,
					duration: durations
				},
				waiting: {
					autoShow: false
				}
			});
		} else {

			mui.openWindow({
				id: id,
				url: a.href,
				show: {
					autoShow: true,
					aniShow: animation,
					duration: durations
				},
				waiting: {
					autoShow: false
				}
			});
		}
	} else {
		if(id && ~id.indexOf('.html')) {

			var href = a.href;
			var taskCode = a.getAttribute('header-taskCode');
			var showSearch = a.getAttribute('showSearch');
			//判断是否显示右上角 +添加  或 √保存 按钮；
			var showButton = !isEmptyOrNull(taskCode) && hasTask(taskCode);
			var showSearch = isEmptyOrNull(showSearch) || showSearch == 'true';
			var title = a.querySelector('.mui-media-body').innerText.trim();

			btn = showButton ? btn : 'none';

			var status = a.getAttribute('dstatus');
			localStorage.setItem('dstatus', status);

			loadListPage('main', title, href, showSearch, btn);
		}
	}
}
/**
 * @description{加载列表页面}
 * @param{templateName}  main | inner
 * @param{title} 页面标题
 * @param{href} 页面地址
 * @param{showSearch} 是否显示搜索按钮
 * @param{btn} 右上角操作按钮， none表示无
 */
function loadListPage(templateName, title, href, showSearch, btn) {

	//获得共用模板组
	var template = getTemplate(templateName);
	//获得共用父模板
	var headerWebview = template.header;
	//获得共用子webview
	var contentWebview = template.content;

	//通知模板修改标题，并显示隐藏右上角图标；
	mui.fire(headerWebview, 'updateHeader', {
		title: title,
		showSearch: showSearch,
		headerButton: btn
	});

	var reload = true;
	if(!template.loaded) {
		if(contentWebview.getURL() != href) {
			contentWebview.loadURL(href);
		} else {
			//每次点击菜单都刷新列表，太费资源，暂不使用
			//contentWebview.evalJS('wList.refresh()');
			reload = false;
		}
	} else {
		reload = false;
	}
	(!reload) && contentWebview.show();
	headerWebview.show(animation, durations);
}

/**非框架代码 BEGIN*/

var server = 'https://wyzf.com.cn';
var address_all = '请选择地址';
var msgBoxTitle = '租房管理',
	buttonCapture = '我知道了',
	confirmButtons = ["是", "否"],
	error_timeout = '哎哟，网络不给力呀',
	loading = '正在玩命加载',
	noroom = '请在 “房源” 中添加房间后，再进行抄表',
	access_denied = '抱歉，您没有此操作权限';

var settings_model = 'wyzf.settings.model',
	user_model = 'wyzf.user.model',
	user_TimeCreated = 'wyzf.user.TimeCreated',
	room_Addresses = 'wyzf.room.addresses';

var pf_down_contentdown = "下拉刷新",
	pf_down_contentover = "释放立即刷新",
	pf_down_contentrefresh = "客官请稍等,正在刷新...",
	pf_up_contentrefresh = "正在刷新...",
	pf_up_contentnomore = "没有更多数据了";

var timeout = 30 * 1000;
var timeouted = false;
var interval = 1500; //加载时间间隔
var autoSearch = 10; //监听搜索框变化时间间隔
var durations = 100;
var rowBackgroundColor = '#F8F9FB'; //列表行背景色
var animation = 'zoom-fade-out';

var taskCode_RoomCreate = "Room_Create",
	taskCode_RoomDelete = "Room_Delete",
	taskCode_RoomUpdate = "Room_Update",
	taskCode_RoomView = "Room_View",
	taskCode_ReceiptCreate = "Receipt_Create",
	taskCode_ReceiptDelete = "Receipt_Delete",
	taskCode_ReceiptUpdate = "Receipt_Update",
	taskCode_ReceiptSetPaid = "Receipt_SetPaid",
	taskCode_ReceiptView = "Receipt_View",
	taskCode_ContractCreate = "Contract_Create",
	taskCode_ContractDelete = "Contract_Delete",
	taskCode_ContractUpdate = "Contract_Update",
	taskCode_ContractView = "Contract_View",
	taskCode_CustomerCreate = "Customer_Create",
	taskCode_CustomerDelete = "Customer_Delete",
	taskCode_CustomerUpdate = "Customer_Update",
	taskCode_CustomerView = "Customer_View",
	taskCode_CustomerCreate = "Customer_Create",
	taskCode_CustomerDelete = "Customer_Delete",
	taskCode_CustomerUpdate = "Customer_Update",
	taskCode_CustomerView = "Customer_View",
	taskCode_NoticeCreate = "Notice_Create",
	taskCode_NoticeDelete = "Notice_Delete",
	taskCode_NoticeUpdate = "Notice_Update",
	taskCode_NoticeView = "Notice_View",
	taskCode_SettingsCreate = "Settings_Create",
	taskCode_SettingsDelete = "Settings_Delete",
	taskCode_SettingsUpdate = "Settings_Update",
	taskCode_SettingsView = "Settings_View",
	taskCode_ReportView = "Report_View",
	taskCode_SettleCreate = "Settle_Create",
	taskCode_SendMessage = "Send_Message",
	taskCode_Manager = 'Manager',
	taskCode_ExpenseCreate = 'Expense_Create';
var user_signlog = 'user.signlog';
var printer_items = 'printer.items';
var default_meterfees = 'default_MeterFees';
var default_fixedfees = 'default_FixedFees';
var settings = getJSONCache(settings_model);

/**
 * 表单数据序列化
 */
function serialize(form) {
	var str = "";
	var elements = form;
	if(form == null) {
		return str;
	}

	for(var i = 0; i < elements.length; i++) {

		var name = elements[i].name;
		if(name != '') {
			str += elements[i].name + '=' + elements[i].value + '&';
		}
	}
	if(str != '')
		str = str.substr(0, str.length - 1);

	return(encodeURI(str));
}

/**
 * @description{表单数据JSON序列化}
 */
function jsonlizeForm(form, data) {

	if(data) {
		for(var i = 0; i < form.length; i++) {
			var item = form[i];
			if(item.name != '') {
				try {
					eval('data.' + item.name + '="' + item.value + '"');
				} catch(e) {
					continue;
				}
			}
		}
		return data;
	} else {
		var str = '{';
		for(var i = 0; i < form.length; i++) {

			var item = form[i];
			if(item.name != '') {
				str += '"' + item.name + '":"' + item.value + '",';
			}
		}
		if(str != '')
			str = str.substr(0, str.length - 1);
		str += '}';
		return JSON.parse(str);
	}
}

function setFormValue(form, model) {

	if(form == null || model == undefined)
		return;
	for(var i = 0; i < form.length; i++) {
		var name = form[i].name;
		if(name != '') {
			var value = eval('model.' + name);
			if(value != undefined) {
				form[i].value = formatValue(value);
			}
		}
	}
}

function formatValue(value) {
	if((typeof value) == 'boolean') {
		value = value.toString();
	} else if((typeof value) == 'number' && value == 0) {
		value = '0';
	} else if(value == '001-01-01') {
		value = '';
	}
	return value;
}

function fixedAmount(amount) {
	if(amount == '' || isNaN(amount)) {
		return 0;
	} else {
		var amountDecimals = parseInt(settings.AmountDecimals);
		return parseFloat(amount).toFixed(amountDecimals);
	}
}

/**
 * 表单数据JSON化
 */
function jsonlize(form) {
	var str = "";
	var elements = form;
	if(form == null) {
		return str;
	}

	str = '{'

	for(var i = 0; i < elements.length; i++) {

		var name = elements[i].name;
		if(name != '') {
			str += elements[i].name + ":'" + elements[i].value + "',";
		}
	}

	if(str != '{')
		str = str.substr(0, str.length - 1);
	str += '}';
	var obj = eval('(' + str + ')');
	return obj;
}

/*
 * 将JSON数据转化为表单字符串
 */
function formlizeJSON(jsonObj) {

	var str = '';
	//遍历属性  
	for(var item in jsonObj) {
		if(item != '')
			str += (item + "=" + jsonObj[item] + '&');
	}
	if(str.length > 0)
		return str.substr(0, str.length - 1);
	else
		return str;
}

/**
 * 验证表单输入
 */
function validateInput(form) {

	var elements = form;
	for(var i = 0; i < elements.length; i++) {

		var value = elements[i].value;
		var required = elements[i].getAttribute('required');
		var type = elements[i].getAttribute('type');
		var tips = elements[i].getAttribute('validateTips');
		var placeholder = elements[i].getAttribute('placeholder');
		var equalTo = elements[i].getAttribute('equalTo');
		var max = elements[i].getAttribute('max');
		var min = elements[i].getAttribute('min');
		var len = elements[i].getAttribute('len');
		var msg = (tips || placeholder) || '';

		if(required == 'required' && value == '') {
			if(tips)
				mui.toast(tips);
			else
				mui.toast(placeholder);
			elements[i].focus();

			return false;
		}

		if(equalTo != null) {
			var v1 = form.querySelector('input[name=' + equalTo + ']').value;
			if(v1 != value) {
				mui.toast('两次输入不一致');
				elements[i].focus();

				return false;
			}
		}

		if(type == 'number') {

			if(max && !isNaN(max) && parseFloat(value) != 0 && parseFloat(value) > parseFloat(max)) {

				mui.toast(msg + '不能大于' + max);
				elements[i].focus();
				return false;
			}
			if(min && !isNaN(min) && parseFloat(value) != 0 && parseFloat(value) < parseFloat(min)) {

				mui.toast(msg + '不能小于' + min);
				elements[i].focus();
				return false;
			}

		} else if(type == 'text' || type == 'password') {

			if(len && !isNaN(len) && (value.length != parseInt(len))) {
				mui.toast('长度必须是' + len + '位');
				elements[i].focus();
				return false;
			}

			if(max && !isNaN(max) && (value.length > parseInt(max))) {
				mui.toast(msg + '长度不能超过' + max);
				elements[i].focus();
				return false;
			}
			if(min && !isNaN(min) && (value.length < parseInt(min))) {

				mui.toast(msg + '长度不能少于' + min);
				elements[i].focus();
				return false;
			}
		}
	}
	var phones = form.querySelectorAll('.phone');
	for(var i = 0; i < phones.length; i++) {

		var valid = validatePhone(phones[i])
		if(!valid) {
			phones[i].focus();
			return false;
		}

	}

	return true;
}

/**
 * 验证输入框内容是否为手机号码
 * @param {Object} phone
 */
function validatePhone(phone) {

	if(phone.value == '') {
		return true;
	}
	if(!isMobileNumber(phone.value)) {
		mui.toast('请输入正确的手机号码');
		phone.focus();
		phone.select();
		return false;
	}
	return true;
}

/**
 * 验证手机号码
 * @param {Object} mobileNumber
 */
function isMobileNumber(mobileNumber) {
	if(mobileNumber == null) {
		return false;
	}
	var isPhone = (mobileNumber.length == 10) || (mobileNumber.length == 11 && /^(((13[0-9]{1})|(14[0-9]{1})|(15[0-9]{1})|(17[0-9]{1})|(18[0-9]{1}))+\d{8})$/.test(mobileNumber));
	if(!isPhone) {
		mui.toast('请输入正确的手机号码');
		return false;
	}
	return true;
}

/**
 * 验证是否为JSON数据
 */

function validateJSON(obj) {
	var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
	return isjson;
}
/*
 * 验证用户登录状态
 */

function validateUser(obj) {
	if(obj != null && typeof obj.IsSucced == 'boolean') {
		if(!obj.IsSucced) {
			mui.toast('连接超时，请重新登录');
			openWindow('login', '../login.html', null, null);
		}
	}
}

function refreshList() {

	//获得列表界面的webview
	//var list = plus.webview.getWebviewById('default-sub');
	var list = plus.webview.currentWebview().opener();
	//触发列表界面的自定义事件（refresh）,从而进行数据刷新
	mui.fire(list, 'refreshList');
	//返回true，继续页面关闭逻辑
	return true;
}

var formatDate = function(dateStr) {

	return dateStr.split(' ')[0];
}

/*
 * Date Format 1.2.3
 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
 * MIT license
 *
 * Includes enhancements by Scott Trenda <scott.trenda.net>
 * and Kris Kowal <cixar.com/~kris.kowal/>
 *
 * Accepts a date, a mask, or a date and a mask.
 * Returns a formatted version of the given date.
 * The date defaults to the current date/time.
 * The mask defaults to dateFormat.masks.default.
 */

var dateFormat = function() {
	var token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function(val, len) {
			val = String(val);
			len = len || 2;
			while(val.length < len) val = "0" + val;
			return val;
		};

	// Regexes and supporting functions are cached through closure
	return function(date, mask, utc) {
		var dF = dateFormat;

		// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
		if(arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}

		// Passing date through Date applies Date.parse, if necessary
		date = date ? new Date(date) : new Date;
		if(isNaN(date)) return ''; //throw SyntaxError("invalid date");

		mask = String(dF.masks[mask] || mask || dF.masks["default"]);

		// Allow setting the utc argument via the mask
		if(mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var _ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d: d,
				dd: pad(d),
				ddd: dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m: m + 1,
				mm: pad(m + 1),
				mmm: dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy: String(y).slice(2),
				yyyy: y,
				h: H % 12 || 12,
				hh: pad(H % 12 || 12),
				H: H,
				HH: pad(H),
				M: M,
				MM: pad(M),
				s: s,
				ss: pad(s),
				l: pad(L, 3),
				L: pad(L > 99 ? Math.round(L / 10) : L),
				t: H < 12 ? "a" : "p",
				tt: H < 12 ? "am" : "pm",
				T: H < 12 ? "A" : "P",
				TT: H < 12 ? "AM" : "PM",
				Z: utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o: (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S: ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default": "ddd mmm dd yyyy HH:MM:ss",
	shortDate: "m/d/yy",
	mediumDate: "mmm d, yyyy",
	longDate: "mmmm d, yyyy",
	fullDate: "dddd, mmmm d, yyyy",
	shortTime: "h:MM TT",
	mediumTime: "h:MM:ss TT",
	longTime: "h:MM:ss TT Z",
	isoDate: "yyyy-mm-dd",
	isoTime: "HH:MM:ss",
	isoDateTime: "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: [
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function(mask, utc) {
	return dateFormat(this, mask, utc);
};

/**
 *@description{根据基础设置信息，设置水电气可见性} 
 */
function setWPGVisibility() {

	var hasWater = true,
		hasPower = true,
		hasGas = true,
		hasNetwork = true,
		hasTV = true,
		hasManagement = true,
		hasGarbage = true,
		hasElevator = true,
		hasOthers = true;

	if(settings.HasWater == false) {
		var items = document.querySelectorAll(".water");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasWater = false;
	}
	if(settings.HasPower == false) {
		var items = document.querySelectorAll(".power");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasPower = false;
	}
	if(settings.HasGas == false) {
		var items = document.querySelectorAll(".gas");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasGas = false;
	}

	if(!hasWater && !hasPower && !hasGas) {
		var items = document.querySelectorAll(".wpg");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
	}

	if(settings.HasNetwork == false) {
		var items = document.querySelectorAll(".network");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasNetwork = false;
	}
	if(settings.HasTV == false) {
		var items = document.querySelectorAll(".tv");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasTV = false;
	}
	if(settings.HasManagement == false) {
		var items = document.querySelectorAll(".management");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasManagement = false;
	}
	if(settings.HasGarbage == false) {
		var items = document.querySelectorAll(".garbage");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasGarbage = false;
	}
	if(settings.HasElevator == false) {
		var items = document.querySelectorAll(".elevator");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasElevator = false;
	}
	if(settings.HasOthers == false) {
		var items = document.querySelectorAll(".others");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
		hasOthers = false;
	}

	if(!hasNetwork && !hasTV && !hasManagement && !hasGarbage && !hasElevator && !hasOthers) {
		var items = document.querySelectorAll(".fixed");
		for(var i = 0; i < items.length; i++) {
			items[i].style.display = 'none'
		}
	}
}

function setItemsVisibility(className, display) {

	var items = document.querySelectorAll(className);

	for(var i = 0; i < items.length; i++) {
		items[i].style.display = display;
	}
}

/*
 * @description 设置输入框可写
 */
function setItemEnable(item) {
	if(item) {
		item.removeAttribute('readonly');
		item.removeAttribute('disabled');
		item.style.color = '#000000';
		item.style.borderBottomColor = '#c8c7cc';
	}
}

/**
 * @description {设置输入框不可用}
 */
function setItemDisable(item) {
	item.readOnly = 'readOnly';
	item.disabled = 'disabled';
	item.style.color = '#999999';
	item.style.borderBottomColor = '#F8F9FB';
}

function setItemsReadOnly(selector) {

	var items = document.querySelectorAll(selector);

	for(var i = 0; i < items.length; i++) {

		if(items[i].getAttribute('alwaysEnabled')) {

			console.log(elements[i].getAttribute('alwaysEnabled'));
			continue;
		}
		if(items[i].tagName.toUpperCase() == 'SELECT') {
			items[i].disabled = 'disabled';
		} else {
			items[i].readOnly = 'readOnly';
		}
		items[i].style.color = '#999999';
		items[i].style.borderBottomColor = '#F8F9FB';
	}
}

function setFormReadOnly(form) {

	var elements = form;
	for(var i = 0; i < elements.length; i++) {

		if(elements[i].getAttribute('alwaysEnabled')) {
			//console.log(elements[i].getAttribute('alwaysEnabled'));
			continue;
		}
		elements[i].readOnly = 'readOnly';
		elements[i].disabled = 'disabled';
		elements[i].style.color = '#999999';
		elements[i].style.borderBottomColor = '#F8F9FB';
	}
}

//调置水电气缓存
function setCache(key, value) {

	localStorage.setItem(key, value);
}

/**
 * @description {获取缓存，为null或undefine时返回空字符串}
 */
function getCache(key) {

	var value = localStorage.getItem(key);
	if(value != null && value != undefined)
		return value;
	else
		return '';
}

/**
 * @description {清除缓存}
 */
function clearCache(key) {
	localStorage.removeItem(key);
}

/**
 * @description {缓存JSON数据}
 */
function setJSONCache(key, data) {

	setCache(key, JSON.stringify(data));
}

/**
 * @description {获取JSON缓存}
 */
function getJSONCache(key) {

	if(getCache(key))
		return JSON.parse(getCache(key));
	else
		return null;
}

/**
 * @description {获取当前登录用户信息}
 */
function getUser() {
	return getJSONCache(user_model);
}

/**
 * @description {设置用户本地缓存}
 */
function setUser(user) {
	setJSONCache(user_model, user);
}

/**
 * @description {获取当前登录用户信息}
 */
function getSettings() {
	return getJSONCache(settings_model);
}

/**
 * @description {设置配置信息本地缓存} 
 */
function setSettings(settings) {
	setJSONCache(settings_model, settings);
}
/**
 * @description {判断当前用户是否有taskCode权限} 
 * @param{String} 权限常量代码
 */
function hasTask(taskCode) {
	var user = getUser();
	var has = false;
	if(user)
		has = user.TaskCodes.indexOf(taskCode) == 0 || user.TaskCodes.indexOf(',' + taskCode) > 0;
	//console.log('user.HasTask(' + taskCode + ')=' + has);
	return has;
}

function addRoom() {
	var extras = {
		roomid: -1
	};
	openWindow('room', 'room.html', null, extras);
}

function validateTask() {

	var elements = document.querySelectorAll('*[taskCode]');
	var length = elements.length;

	for(var i = 0; i < length; i++) {
		var code = elements[i].getAttribute('taskCode');
		if(!hasTask(code))
			elements[i].style.display = 'none';
	}
}
/**
 *@description{提示框}
 */
function wAlert(message) {
	plus.ui.alert(message, null, msgBoxTitle, buttonCapture);
}
/**
 *@description{获取时间戳，格式yyyy-m-d HH:MM:ss}
 *@param{JSON} 为null或不填时，取当前时间
 */
function getTimestamp(data) {
	var now = dateFormat(new Date(), 'yyyy-m-d HH:MM:ss');
	var timestamp = (data == null) ? now : data.TimeUpdated;
	return timestamp;
}

/*
 * @description: 用于发送请求时，获取时间动态参数
 */
function getTime() {
	return new Date().getTime();
}

/*
 * @description: mui.openWindow方式打开页面
 * @param{id:页面id}
 * @param{url:页面URL}
 * @param{event:需要触发的事件}
 */
function openWindow(id, url, event, extras) {

	if(url && url != '') {
		var profiles = plus.webview.getWebviewById(id);
		if(profiles) {
			if(event)
				profiles.evalJS(event);
			profiles.show(animation, durations);
		} else {
			mui.openWindow({
				id: id,
				url: url,
				extras: extras,
				show: {
					autoShow: true,
					aniShow: animation,
					duration: durations
				},
				waiting: {
					autoShow: false
				},
				styles: {
					render: 'always'
				}
			});
		}
	}
}

/**
 * @description {ios下日期输入框 unit会显示不全,改用unit-ios-date}
 */
function setDateCssHack(element) {

	if(mui.os.ios) {
		element.className = 'unit-ios-date';
	}
}

/**
 * @description {将日期字符串转日期}
 */
function parseDate(dateString) {
	var str = dateString.replace(/-/g, "/");
	return new Date(str);
}

/**
 *@description{根据地址长度，动态调整select控件宽度} 
 */
function setAddressWidth() {
	var addresses = document.getElementById("addresses");
	if(addresses.value != '') {
		var maxWidth = screen.width - 120;
		var len = (addresses.value.length + 3) * 16;
		if(len > maxWidth) {
			len = maxWidth;
		}
		addresses.style.width = len + 'px';
	} else {
		addresses.style.width = '120px';
	}
}

function refreshIndexMenu() {
	var list = plus.webview.getWebviewById('index-menu');
	mui.fire(list, 'refreshList');
}

function getPrintContent(data) {

	var bill = '\r\n==' + data.TimeReceiptDesc + '月份房租单==\r\n';
	var print = getJSONCache(printer_items);
	var settings = getSettings();

	if(print && print.Custom) {
		if(print.CustomerName)
			bill += '\r\n姓名: ' + data.CustomerName;
		if(print.CustomerPhone)
			bill += '\r\n电话: ' + data.CustomerPhone;
		if(print.RoomAddress)
			bill += '\r\n地址: ' + data.RoomAddress;
		if(print.RoomNumber)
			bill += '\r\n房号: ' + data.RoomNumber;
		if(print.Range)
			bill += '\r\n租期: ' + data.TimeStartFormatted + '至' + data.TimeEndFormatted;
		if(print.Basic)
			bill += '\r\n\r\n租金: ￥' + data.Basic;
		if(print.Water) {
			bill += '\r\n用水: ' + data.WaterConsume + '吨  注：(' + data.WaterQuantity + '-' + data.LastWaterQuantity + ')';
			bill += '\r\n水费:￥' + data.Water + ' 注：(' + data.WaterConsume + '*' + data.WaterPrice + ')';
		}
		if(print.Power) {
			bill += '\r\n用电:' + data.PowerConsume + '度  注：(' + data.PowerQuantity + '-' + data.LastPowerQuantity + ')';
			bill += '\r\n电费:￥' + data.Power + ' 注：(' + data.PowerConsume + '*' + data.PowerPrice + ')';
		}
		if(print.Gas) {
			bill += '\r\n用: ' + settings.CustomNameGas + ': ' + data.GasConsume + '方  注：(' + data.GasQuantity + '-' + data.LastGasQuantity + ')';
			bill += '\r\n' + settings.CustomNameGas + '费:￥' + data.Gas + ' 注：(' + data.GasConsume + '*' + data.GasPrice + ')';
		}
		if(print.Network)
			bill += '\r\n' + settings.CustomNameNetwork + ': ￥' + data.Network;
		if(print.Management)
			bill += '\r\n' + settings.CustomNameManagement + ': ￥' + data.Management;
		if(print.TV)
			bill += '\r\n' + settings.CustomNameTV + ': ￥' + data.TV;
		if(print.Garbage)
			bill += '\r\n' + settings.CustomNameGarbage + ': ￥' + data.Garbage;
		if(print.Elevator)
			bill += '\r\n' + settings.CustomNameElevator + ': ￥' + data.Elevator;
		if(print.Others)
			bill += '\r\n' + settings.CustomNameOthers + ': ￥' + data.Others;
		if(data.Balance != 0)
			bill += '\r\n抵扣：￥' + data.Balance;
		if(print.Remark)
			bill += '\r\n备注: ' + data.Remark;
		bill += '\r\n\r\n==合计 ￥' + data.Total + ' ==';
		if(print.Account && settings.BankName != '' && settings.AccountName != '' && settings.AccountNumber != '') {
			bill += '\r\n\r\n==房东收款账户==\r\n\r\n' + settings.BankName + '\r\n户名：' + settings.AccountName + '\r\n账号：' + settings.AccountNumber;
		}
	} else {
		if(data.CustomerName != '' && data.CustomerName != data.RoomNumber && data.CustomerName != data.RoomAddress) {
			bill += '\r\n姓名: ' + data.CustomerName;
		}
		bill += '\r\n地址: ' + data.RoomAddress;
		bill += '\r\n房号: ' + data.RoomNumber;
		bill += '\r\n\r\n租金: ￥' + data.Basic;
		if(data.Water > 0) {
			bill += '\r\n用水: ' + data.WaterConsume + '吨  注：(' + data.WaterQuantity + '-' + data.LastWaterQuantity + ')';
			bill += '\r\n水费:￥' + data.Water + ' 注：(' + data.WaterConsume + '*' + data.WaterPrice + ')';
		}
		if(data.Power > 0) {
			bill += '\r\n用电:' + data.PowerConsume + '度  注：(' + data.PowerQuantity + '-' + data.LastPowerQuantity + ')';
			bill += '\r\n电费:￥' + data.Power + '  注：(' + data.PowerConsume + '*' + data.PowerPrice + ')';
		}
		if(data.Gas > 0) {
			bill += '\r\n用: ' + settings.CustomNameGas + ': ' + data.GasConsume + '方  注：(' + data.GasQuantity + '-' + data.LastGasQuantity + ')';
			bill += '\r\n' + settings.CustomNameGas + '费:￥' + data.Gas + ' 注：(' + data.GasConsume + '*' + data.GasPrice + ')';
		}
		if(data.Network > 0)
			bill += '\r\n' + settings.CustomNameNetwork + ': ￥' + data.Network;
		if(data.Management > 0)
			bill += '\r\n' + settings.CustomNameManagement + ': ￥' + data.Management;
		if(data.TV > 0)
			bill += '\r\n' + settings.CustomNameTV + ': ￥' + data.TV;
		if(data.Garbage > 0)
			bill += '\r\n' + settings.CustomNameGarbage + ': ￥' + data.Garbage;
		if(data.Elevator > 0)
			bill += '\r\n' + settings.CustomNameElevator + ': ￥' + data.Elevator;
		if(data.Others > 0)
			bill += '\r\n' + settings.CustomNameOthers + ': ￥' + data.Others;
		if(data.Balance != 0)
			bill += '\r\n抵扣：￥' + data.Balance;
		if(data.Remark != '')
			bill += '\r\n备注: ' + data.Remark;
		if(data.Total > 0)
			bill += '\r\n\r\n==合计 ￥' + data.Total + ' ==';
		if(settings.BankName != '' && settings.AccountName != '' && settings.AccountNumber != '') {
			bill += '\r\n\r\n==房东收款账户==\r\n\r\n' + settings.BankName + '\r\n户名：' + settings.AccountName + '\r\n账号：' + settings.AccountNumber;
		}
	}

	//附言
	bill += '\r\n\r\n' + settings.PostScript;

	return bill;
}

function getPrintContentF(data) {

	var bill = '\r\n==' + data.TimeReceiptDesc + '月份房租单==\r\n';
	var print = getJSONCache(printer_items);
	var settings = getSettings();

	if(print && print.Custom) {
		if(print.CustomerName)
			bill += '\r\n姓名: ' + data.CustomerName;
		if(print.CustomerPhone)
			bill += '\r\n电话: ' + data.CustomerPhone;
		if(print.RoomAddress)
			bill += '\r\n地址: ' + data.RoomAddress;
		if(print.RoomNumber)
			bill += '\r\n房号: ' + data.RoomNumber;
		if(print.Range)
			bill += '\r\n租期: ' + data.TimeStartFormatted + '至' + data.TimeEndFormatted;

		mui.each(wEdit.data.ReceiptDtList, function(i, f) {
			switch(f.FeeType) {
				case 'Rent':
				case 'Normal':
					bill += '\r\n' + f.FeeName + ': ' + f.Fee;
					break;
				case 'Water':
				case 'Power':
				case 'Gas':
				case 'HotWater':
					bill += '\r\n' + f.FeeName.substr(0, f.FeeName.length - 1) + '费: ' + f.Fee + ' 注：（' + f.CurrMeterNum + '-' + f.PreMeterNum + '）*' + f.MeterPrice;
					break;
			}
		});

		if(data.Balance != 0)
			bill += '\r\n抵扣：￥' + data.Balance;
		if(print.Remark)
			bill += '\r\n备注: ' + data.Remark;
		bill += '\r\n\r\n==合计 ￥' + data.Total + ' ==';
		if(print.Account && settings.BankName != '' && settings.AccountName != '' && settings.AccountNumber != '') {
			bill += '\r\n\r\n==房东收款账户==\r\n\r\n' + settings.BankName + '\r\n户名：' + settings.AccountName + '\r\n账号：' + settings.AccountNumber;
		}
	} else {
		if(data.CustomerName != '' && data.CustomerName != data.RoomNumber && data.CustomerName != data.RoomAddress) {
			bill += '\r\n姓名: ' + data.CustomerName;
		}
		bill += '\r\n地址: ' + data.RoomAddress;
		bill += '\r\n房号: ' + data.RoomNumber;
		bill += '\r\n租期: ' + data.TimeStartFormatted + '至' + data.TimeEndFormatted;
		mui.each(data.ReceiptDtList, function(i, f) {
			switch(f.FeeType) {
				case 'Rent':
				case 'Normal':
					bill += '\r\n' + f.FeeName + ': ' + f.Fee;
					break;
				case 'Water':
					bill += '\r\n水费: ' + f.Fee + ' 注：（' + f.CurrMeterNum + '-' + f.PreMeterNum + '）*' + f.MeterPrice;
					break;
				case 'Power':
					bill += '\r\n电费: ' + f.Fee + ' 注：（' + f.CurrMeterNum + '-' + f.PreMeterNum + '）*' + f.MeterPrice;
					break;
				case 'Gas':
					bill += '\r\n气费: ' + f.Fee + ' 注：（' + f.CurrMeterNum + '-' + f.PreMeterNum + '）*' + f.MeterPrice;
					break;
				case 'HotWater':
					bill += '\r\n热水费: ' + f.Fee + ' 注：（' + f.CurrMeterNum + '-' + f.PreMeterNum + '）*' + f.MeterPrice;
					break;
			}
		});
		if(data.Balance != 0)
			bill += '\r\n抵扣：￥' + data.Balance;
		if(data.Remark != '')
			bill += '\r\n备注: ' + data.Remark;
		bill += '\r\n\r\n==合计 ￥' + data.Total + ' ==';

		if(settings.BankName != '' && settings.AccountName != '' && settings.AccountNumber != '') {
			bill += '\r\n\r\n==房东收款账户==\r\n\r\n' + settings.BankName + '\r\n户名：' + settings.AccountName + '\r\n账号：' + settings.AccountNumber;
		}
	}
	return bill;
}
/**
 * @description 查看大图
 * */
function showImg(imgSrc) {
	var url = "/pages/imageViewer.html";
	var imageViewer = plus.webview.create(url, url, {
		scrollIndicator: 'none',
		scalable: true,
		bounce: "all"
	});
	imageViewer.addEventListener("loaded", function() {
		imageViewer.evalJS("loadMedia('" + imgSrc + "')");

	}, false);
	imageViewer.addEventListener("close", function() {
		imageViewer = null;
	}, false);
	imageViewer.show("pop-in");
}

/**
 * @description {判断字符串是否为 '' 或 null 或undefined}
 */
function isEmptyOrNull(str) {
	//console.log(str);
	return str == null || str == '' || str == undefined || str == 'undefined';
}

/**
 * @description {当前用户使用的是否为新版}
 */
function isNewVersion() {
	return hasTask('FRoom_View') || hasTask('FReceipt_View');
}

/**
 * @description {当前用户使用的是否为新版}
 */
function setReceiptDays() {
	var selectReceiptDays = document.querySelector('select[name=DayReceipt]');
	for(var i = 1; i <= 30; i++) {
		var opt = document.createElement('option');
		opt.value = i;
		opt.text = i + ' 号';
		selectReceiptDays.appendChild(opt);
	}
}

function reportError(xhr, type, errorThrown) {
	mui.plusReady(function() {
		var dt = new Date().getTime();
		var error_url = server + '/Handler/ErrorHandler.ashx?action=save&LogType=Error&Content=statusCode:' + xhr.status + ', statusText:' + xhr.statusText + ', type:' + type + ', msg:' + JSON.stringify(errorThrown) + ', app_version:' + plus.runtime.version + '&dt=' + dt;
		mui.getJSON(error_url);
		console.log(error_url)
	})
}

/**
 * 获取月份的最后一天
 * @param {Object} year
 * @param {Object} month
 */
function getMonthLastDay(year, month) {
	//var   firstdate = year + '-' + month + '-01';  
	var day = new Date(year, month, 0);
	var lastdate = year + '-' + month + '-' + day.getDate(); //获取当月最后一天日期    
	return lastdate.toString();
}

/**
 * 获取两个日期之间的天数
 * @param {Object} strDate1 yyyy-MM-dd
 * @param {Object} strDate2 yyyy-MM-dd
 */
function getDays(strDate1, strDate2) { //sDate1和sDate2是2006-12-18格式  
	var aDate = strDate1.split('-');
	var oDate1 = new Date(aDate[1] + '-' + aDate[2] + '-' + aDate[0]); //转换为12-18-2006格式  
	aDate = strDate2.split('-');
	var oDate2 = new Date(aDate[1] + '-' + aDate[2] + '-' + aDate[0]);
	var iDays = parseInt(Math.abs(oDate1 - oDate2) / 1000 / 60 / 60 / 24); //把相差的毫秒数转换为天数  
	return iDays + 1;
}

/**
 * 获取strDate距离下月的天数
 * @param {Object} strDate
 */
function getMonthLeftDays(startDate) {
	var info = startDate.split('-');
	var lastDate = getMonthLastDay(info[0], info[1]);
	return getDays(lastDate, startDate);
}

/**
 * 调NativeJS发送短信
 * @param {String} phone
 * @param {String} content
 */
function sendMessage(phone, content) {

	if(!isMobileNumber(phone)) {
		mui.toast('请填写正确的手机号码');
		return;
	}
	var msg = plus.messaging.createMessage(plus.messaging.TYPE_SMS);
	msg.to = [phone];
	msg.body = content;
	msg.silent = false;
	plus.messaging.sendMessage(msg);
}
/*非框架内代码 END*/