/**
 *@description 列表公用类
 */
var wList = {

	type: 'Room',
	url: 'xxxhandler url?action=xxx',
	handlerURL: '',
	hasAddress: true,
	hasCheckBoxs: true,
	recordtotal: 0,
	pagetotal: 0,
	pageindex: 0,
	pagesize: 25,
	canSearch: true,
	address_selected: '',
	dateStart: '',
	dateEnd: '',
	order: '',
	isAscending: false,
	status: {
		show: true,
		code: 'empty',
		desc: "空房"
	},
	editPage: {
		url: 'room.html',
		id: 'room'
	},
	/**
	 *@description 查看详情，页面跳转前的操作
	 */
	beforeView: function(id) {
		setCache(wList.type + '_id', id);
	},
	/**
	 *@description 空数据时显示
	 * @param {divTips} 显示的DIV
	 */
	empty: function(divTips) {
		//空数据时,DIV展示	
		divTips.style.display = 'block';
	},
	/**
	 *@description 构建列表的行数据
	 * @param {data} 实体
	 */
	buildRow: function(data) {},
	/**
	 *@description 显示总结果条数
	 *@param {recordTotal} 总记录条数
	 *@param {keywords} 查询关键字
	 *@param {divResult} 显示查询结果数量的DIV
	 *@param {args} 附加的结果值
	 */
	showTotalResult: function(recordTotal, keywords, divResult, args) {},
	/**
	 *@description 初始化列表数据
	 *@param {JSON} 初始化列表配置参数 type:实体名称,hasAddress:是否包含地址列表,hasCheckBoxs:是否包批量操作
	 *
	 */
	init: function(options) {

		var config = options || {};
		listDataType = config.type + 's'; //rooms,receipts....
		wList.type = config.type;
		wList.handlerURL = server + '/Handler/' + wList.type + 'Handler.ashx';
		wList.url = config.url || (wList.handlerURL + '?action=search');

		wList.hasAddress = config.hasAddress;
		wList.hasCheckBoxs = config.hasCheckBoxs;
		wList.canSearch = config.canSearch != undefined ? config.canSearch : wList.canSearch;
		wList.status = config.status || wList.status;
		wList.editPage = config.editPage || wList.editPage;
		wList.pagesize = config.pagesize || wList.pagesize;
		wList.empty = config.empty || wList.empty;
		wList.buildRow = config.buildRow || wList.buildRow;
		wList.showTotalResult = config.showTotalResult || wList.showTotalResult;

		mui.init({
			swipeBack: false,
			pullRefresh: {
				container: '#pullrefresh',
				down: {
					callback: pulldownRefresh //必选，刷新函数，
				},
				up: {
					callback: pullupRefresh
				}
			}
		});

		if (!config.customReady) {
			if (mui.os.plus) {
				mui.plusReady(function() {
					wList.setAddresses();
					wList.setPageArgs();
				});
			}
		}

		if (!config.customView) {
			//查看
			mui('.mui-content').on('tap', '.mui-slider-handle', function(e) {
				if (wList.hasCheckBoxs && wSelect.showCheckBoxs) {
					var chk = this.querySelector('input[type=checkbox]');
					if (chk) chk.checked = !chk.checked;
				} else {
					var id = this.getAttribute('id');
					wList.beforeView(id);

					var extras = {
						itemid: id
					};
					openWindow(wList.editPage.id, wList.editPage.url, null, extras);
				}
			});
		};

		if (!config.customDelete) {
			//删除
			mui('.mui-content').on('tap', '.mui-btn-red', function(e) {
				var id = this.getAttribute('id');
				var table = document.body.querySelector('.mui-table-view');
				var li = this.parentElement.parentElement;
				//mui.toast(id);
				mui.confirm("确定要删除吗?", msgBoxTitle, confirmButtons, function(e) {
					if (e.index == 0) {
						var data = {
							ids: id
						};
						mui.getJSON(wList.handlerURL + '?action=deletes', data, function(result) {

							if (result.IsSucced) {
								mui.toast(result.Message);
								table.removeChild(li);

								var keywords = wList.getKeywords();
								var divResult = document.querySelector('.searchResult');

								//更新结果条数
								wList.recordtotal--;
								wList.showTotalResult(wList.recordtotal, keywords, divResult);
								if (wList.recordtotal == 0) {
									if (typeof wSelect != 'undefined') {
										wSelect.disableChecked();
										if (wList.type != 'room' && wList.type != 'froom')
											setItemsVisibility('#btnChecked', 'none');
									}
								}
								refreshIndexMenu();
							} else {
								wAlert(result.Message);
							}
						})
					}
				});
			});
		};
		/**
		 *@description{下拉刷新具体业务实现}
		 */
		function pulldownRefresh() {
			setTimeout(function() {
				wList.refresh();
			}, interval);
		};
		/**
		 *@description{上拉加载具体业务实现}
		 */
		function pullupRefresh() {
			setTimeout(function() {
				mui('#pullrefresh').pullRefresh().endPullupToRefresh((++wList.pageindex > wList.pagetotal)); //参数为true代表没有更多数据了。
				wList.search();
			}, interval);
		};

		window.addEventListener('refreshList', function(msg) {

			if (wList.type == 'room' || wList.type == 'froom') {
				var addressNew = localStorage.getItem('addressNew');
				if (addressNew && addressNew != '') {
					wList.address_selected = addressNew;
					wList.setAddresses();
					localStorage.removeItem('addressNew');
				}
				if (typeof wSelect != "undefined")
					wSelect.disableChecked();
			}
			wList.refresh();
			//更新主页 index-menu.html 显示内容		
			if (wList.type == 'room' || wList.type == 'contract' || wList.type == 'receipt' ||
				wList.type == 'froom' || wList.type == 'fcontract' || wList.type == 'freceipt') {
				refreshIndexMenu();
			}
		});

		if (wList.status.show) {

			//状态更改后刷新列表
			mui("#bottomPopover").on('tap', 'li', function(e) {

				document.getElementById("lblType").innerText = this.innerText;
				wList.status.code = this.querySelector('div>input[name=checkbox]').value;
				wList.status.desc = this.querySelector('div>label').innerText;
				mui('#bottomPopover').popover('toggle');
				wList.refresh();
			})
		}

		if (wList.hasAddress) {

			document.getElementById('addresses').addEventListener('change', function() {

				setAddressWidth();

				wList.address_selected = this.value;
				if (wList.address_selected != address_all) {
					settings.Address = wList.address_selected;
					setJSONCache(settings_model, settings);
				}

				wList.refresh();
			})
		}
	},
	/**
	 *@description 刷新列表，搜索
	 */
	refresh: function() {
		document.body.querySelector('.mui-table-view').innerHTML = "";
		mui('#pullrefresh').pullRefresh().refresh(true); //刷新时重置，否则无法上拉
		wList.setPageArgs();
	},
	/**
	 *@description{获取分页相关参数，并获取首页数据}
	 */
	setPageArgs: function() {
		wList.pageindex = 1;

		var url = wList.url + '&page=true&dt=' + getTime();
		var txtSearch = document.getElementById("search") || {};
		var btnChecked = document.getElementById("btnChecked");

		wList.getStatusFromMenu();

		var args = {
			keywords: wList.getKeywords(),
			address: wList.address_selected == address_all ? '' : wList.address_selected,
			size: wList.pagesize,
			status: wList.status.code,
			dateStart: wList.dateStart,
			dateEnd: wList.dateEnd,
			order: wList.order,
			isAscending: wList.isAscending
		};

		//console.log(JSON.stringify(args));

		mui.ajax(url, {
			data: args,
			timeout: timeout,
			dataType: 'json',
			type: 'get',
			success: function(data) {
				wList.setPageArgsView(data);
				wList.search();
			},
			error: function(xhr, type, errorThrown) {
				reportError(xhr,type,errorThrown);
				//异常处理；
				mui.toast(error_timeout);
				mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); //数据加载完成后，再关闭提示
			}
		})
	},
	setPageArgsView: function(data) {
		wList.pagetotal = data.TotalPages;
		wList.recordtotal = data.TotalResults;
		var divTips = document.querySelector('.mui-error');
		var divResult = document.querySelector('.searchResult');
		var keywords = wList.getKeywords();

		if (wList.recordtotal > 0) {
			divTips.style.display = 'none';

			if (wList.hasCheckBoxs) {
				btnChecked.style.display = 'inline-block';
			}
			wList.showTotalResult(wList.recordtotal, keywords, divResult, data.Tag);
		} else {
			divResult.innerText = '';
			divTips.style.display = 'block';

			wList.empty(divTips);

			if (keywords != '')
				divTips.innerHTML = 'O_O! 没有找到符合条件的记录。';

			if (wList.hasCheckBoxs) {
				if (wList.type == 'room' || wList.type == 'froom') //房源允许批量新增操作
					btnChecked.style.display = 'inline-block';
				else
					btnChecked.style.display = 'none';
				wSelect.disableChecked();
			}
		}
	},
	getKeywords: function() {
		return getCache('keywords') || '';
	},
	/**
	 * @description{点击菜单进入，把菜单对应的状态取出来查询}
	 */
	getStatusFromMenu: function() {

		//根据菜单点击过来的状态，进行搜索BEGIN
		var statusCode = localStorage.getItem('dstatus'); //如点击：提醒，空房，待收
		if (statusCode && statusCode != 'null' && statusCode != '') {
			clearCache('dstatus');
			wList.status.code = statusCode == 'all' ? '' : statusCode;
			//设置选中项
			mui("#bottomPopover li").each(function(i, item) {

				var checkbox = item.querySelector('input[name=checkbox]');
				var label = item.querySelector('label');

				if (checkbox.value == wList.status.code) {
					checkbox.checked = true;
					document.getElementById("lblType").innerText = label.innerText;
				}
			})
		}
	},
	/**
	 * @description{查询分页数据}
	 */
	search: function() {

		if (wList.pageindex > wList.pagetotal) {
			mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); //数据加载完成后，再关闭提示
			return;
		}

		var data = {
			keywords: wList.getKeywords(),
			address: wList.address_selected == address_all ? '' : wList.address_selected,
			index: wList.pageindex,
			size: wList.pagesize,
			status: wList.status.code,
			dateStart: wList.dateStart,
			dateEnd: wList.dateEnd,
			order: wList.order,
			isAscending: wList.isAscending
		};

		mui.ajax(wList.url + '&dt=' + getTime(), {
			data: data,
			timeout: timeout,
			dataType: 'json',
			type: 'get',
			success: function(datas) {
				validateUser(datas);
				wList.setSearchView(datas);
			},
			error: function(xhr, type, errorThrown) {
				reportError(xhr,type,errorThrown);
				//异常处理；
				mui.toast(error_timeout);
				mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); //数据加载完成后，再关闭提示
			}
		})
	},
	setSearchView: function(datas) {
		if (datas != null) {
			var table = document.body.querySelector('.mui-table-view');
			if (wList.pageindex == 1) {
				table.innerHTML = '';
			}
			var cells = document.body.querySelectorAll('.mui-table-view-cell');
			var len = datas.length;
			for (var i = 0; i < len; i++) {
				var data = datas[i];
				var li = wList.buildRow(data);
				table.appendChild(li);

				setJSONCache(wList.type + '_' + li.getAttribute('id'), data);
			}

			table.style.boxShadow = '1px 1px 2px #aaaaaa';

			validateTask();
			mui('#pullrefresh').pullRefresh().endPulldownToRefresh(); //数据加载完成后，再关闭提示
		}
	},
	setAddresses: function() {

		//缓存
		wList.cacheDefaultFixedFees();
		wList.cacheDefaultMeterFees();

		if (!wList.hasAddress)
			return;

		var datas = getJSONCache(room_Addresses);
		if (datas && wList.type != 'room' && wList.type != 'froom') {
			wList.setAddressesView(datas);
		} else {
			var url = server + '/Handler/RoomHandler.ashx?action=addresses';
			if (wList.type.indexOf('f') == 0) {
				url = server + '/Handler/FRoomHandler.ashx?action=addresses';
			}

			mui.getJSON(url, function(datas) {

				var isSystem = getUser().IsSuper;
				if (datas != null) {

					wList.setAddressesView(datas);
					setJSONCache(room_Addresses, datas);

				} else if (wList.type != 'room' && wList.type != 'froom' && !isSystem) {
					mui.confirm("还没有房源呢，立即添加？", msgBoxTitle, ["好", "一会再说"],
						function(e) {
							if (e.index == 0) {
								addRoom();
							}
						});
				}
			})
		}
	},
	setAddressesView: function(datas) {
		if (!wList.hasAddress || datas == null || datas.length == 0) {
			clearCache(room_Addresses)
			setItemsVisibility('#addresses', 'none');
			return;
		}
		setItemsVisibility('#addresses', 'inline-block');
		var addresses = document.getElementById("addresses");

		var empty = document.createElement('option');
		empty.innerText = address_all;
		empty.value = '';

		addresses.innerHTML = '';
		addresses.appendChild(empty);

		var len = datas.length;

		for (var i = 0; i < len; i++) {
			var data = datas[i];
			var address = document.createElement('option');
			address.innerText = data.Address;
			address.value = data.Address;
			addresses.appendChild(address);
		}
		if (wList.address_selected == '') {
			wList.address_selected = address_all;
		} else {
			addresses.value = wList.address_selected;
		}
		setAddressWidth();
	},
	cacheDefaultFixedFees: function() {

		var datas = getJSONCache(default_fixedfees);
		if (datas && (wList.type != 'froom' && wList.type != 'freceipt' && wList.type != 'fcontract')) {
			//mui.toast(wList.type);
		} else {
			mui.getJSON(server + '/Handler/FRoomHandler.ashx?action=FESetting&type=f&ts=' + getTimestamp(), function(datas) {
				//console.log(datas);
				if (datas != null) {
					setJSONCache(default_fixedfees, datas);
				}
			})
		}
	},
	cacheDefaultMeterFees: function() {
		
		var datas = getJSONCache(default_meterfees);
		if (datas && (wList.type != 'froom' && wList.type != 'freceipt' && wList.type != 'fcontract')) {
			//mui.toast(wList.type);
		} else {
			mui.getJSON(server + '/Handler/FRoomHandler.ashx?action=FESetting&type=m&ts=' + getTimestamp(), function(datas) {
				//console.log(datas);
				if (datas != null) {
					setJSONCache(default_meterfees, datas);
				}
			})
		}
	}
}