/**
 *@description {蓝牙打印通用类（Android）}
 */
var wPrinter = {
	device: null,
	adapter: null,
	socket: null,
	uuid: null,
	BluetoothAdapter: null,
	/**
	 *@description {初始化，页面关闭前关闭套接字}
	 */
	init: function() {
		mui.init({
			beforeback: function() {
				if (wPrinter.socket) {
					//console.log('close socket before back');
					wPrinter.socket.close();
				}
			}
		});
	},

	/**
	 *@description {检测并打开蓝牙}
	 */
	open: function() {
		if (wPrinter.BluetoothAdapter == null) {
			wPrinter.BluetoothAdapter = plus.android.importClass("android.bluetooth.BluetoothAdapter");
			var UUID = plus.android.importClass("java.util.UUID");
			wPrinter.uuid = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
			wPrinter.adapter = wPrinter.BluetoothAdapter.getDefaultAdapter(); //获得本机蓝牙适配器
			if (!wPrinter.adapter.isEnabled()) {
				mui.toast('检测到未打开蓝牙,尝试打开中....');
				wPrinter.adapter.enable();
				mui.toast('已成功打开')
			}
		}
	},
	/**
	 *@description {获取已配对的蓝牙设备}
	 */
	getDevices: function() {

		wPrinter.open();

		var lists = wPrinter.adapter.getBondedDevices(); //获取配对的设备列表
		plus.android.importClass(lists);
		var iterator = lists.iterator();
		plus.android.importClass(iterator);
		var ul = document.getElementById('list');
		ul.innerHTML = '';

		var devices = new Array();
		var i = 0;
		while (iterator.hasNext()) {

			var d = iterator.next();
			plus.android.importClass(d);

			var device = {
				address: d.getAddress(),
				name: d.getName()
			};
			devices[i++] = device;
		}
		return devices;
	},
	/**
	 *@description {开始打印}
	 * @param {mac_address} 打印机的mac地址
	 * @param {str} 要打印的内容
	 */
	printBySelected: function(mac_address, contentStr) {

		if (!mac_address) {
			mui.toast('请选择蓝牙打印机');
			return;
		}
		wPrinter.open();

		if (wPrinter.device == null || wPrinter.device.getAddress() != mac_address || wPrinter.socket == null) {

			wPrinter.device = wPrinter.adapter.getRemoteDevice(mac_address);
			plus.android.importClass(wPrinter.device);

			wPrinter.socket = wPrinter.device.createInsecureRfcommSocketToServiceRecord(wPrinter.uuid);
			plus.android.importClass(wPrinter.socket);
		}
		if (!wPrinter.socket.isConnected()) {
			//mui.toast('检测到设备未连接，尝试连接中....');
			wPrinter.socket.connect();
		}
		
		if (wPrinter.socket.isConnected()) {
			var outputStream = wPrinter.socket.getOutputStream();
			plus.android.importClass(outputStream);
			var bytes = plus.android.invoke(contentStr, 'getBytes', 'GBK');
			outputStream.write(bytes);
			outputStream.flush();
			
		} else {
			localStorage.removeItem('mac_address');
			wAlert('设备连接失败，请确定\r\n\r\n1.选择的设备是蓝牙打印机\r\n2.打印机电源开关已打开\r\n3.打印机未被其他设备占用\r\n');
		}
		//改为退出本页面时关闭
		//socket.close();
	},
	/**
	 *@description {使用最近一次设备，进行打印}
	 * @param {str} 要打印的内容
	 */
	print: function(str) {

		str += '\r\n\r\n打印时间：' + dateFormat(new Date(), 'yyyy-mm-dd HH:MM:ss') + '\r\n\r\n\r\n';		
		localStorage.setItem('print_content',str);
		
		var mac_address = localStorage.getItem('mac_address');
		if (mac_address != null) {
			//try {
				wPrinter.printBySelected(mac_address, str);
			//} catch (ex) {
				//wAlert('连接失败，请确保蓝牙已开且成功配对');
			//}
		} else {
			openWindow('printer', 'printer.html', null, null);
		}
	}
}